#/bin/bash
echo "================= Moxa migration checking tool ================="
echo "Start checking.............."
echo "================= Check USB ================="
grep -r -n "/mnt/usbstorage" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "/mnt/usbstorage" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "Please use new definitions: /media/usb0"
fi
echo ""
echo "================= Check SD card ================="
grep -r -n "/mnt/sd" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "/mnt/sd" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "Please use new definitions: /media/sd-mmcblk1p"
fi
echo ""

echo "================= Check CF card ================="
grep -r -n "/mnt/cf" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "/mnt/cf" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "There is no CF card Peripheral for Cortex-A8 platform, please modify/remove it"
fi
echo ""

echo "================= Check RTC ================="
grep -r -n "/dev/rtc" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "/dev/rtc" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "Please use new definitions: /dev/rtc0"
fi
echo ""
echo "================= Check Buzzer ================="
grep -r -n "/dev/console" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "/dev/console" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "Please use new Buzzer API"
fi
echo ""
echo "================= Check UART mode API ================="
grep -r -n "MOXA_SET_OP_MODE" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "KDMKTONE" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "int ioctl(fd, MOXA_SET_OP_MODE, &mode)  must be modified/removed. Cortex-A8 platform adopts new API calls, Please use new definitions:  mx_uart_init(), mx_uart_set_mode(),  mx_uart_get_mode()..."
fi
echo ""
grep -r -n "MOXA_GET_OP_MODE," --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "KDMKTONE" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "int ioctl(fd, MOXA_GET_OP_MODE, &mode)  must be modified/removed. Cortex-A8 platform adopts new API calls, Please use new definitions:  mx_uart_init(), mx_uart_set_mode(),  mx_uart_get_mode()..."
fi
echo ""



echo "================= Check Watchdog API ================="
grep -r -n "swtd_open" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "swtd_open" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "swtd_open must be modified/removed. Cortex-A8 platform adopts new API calls, Please use new definitions:  open(\"/dev/watchdog\",O_RDWR)"
fi
echo ""
grep -r -n "swtd_ack" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "swtd_ack" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "swtd_ack() must be modified/removed. Cortex-A8 platform adopts new API calls, Please use new definitions:  int ioctl(fd, WDIOC_KEEPALIVE, 0)"
fi
echo ""
grep -r -n "swtd_enable" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "swtd_enable" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "ioctl(fd, KDMKTONE, unsigned int arg) must be modified/removed. Cortex-A8 platform adopts new API calls, Please use new definitions:  ioctl(fd, WDIOC_SETTIMEOUT, &timeout)"
fi
echo ""
grep -r -n "swtd_get" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "swtd_get" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "ioctl(fd, KDMKTONE, unsigned int arg) must be modified/removed. Cortex-A8 platform adopts new API calls, Please use new definitions:  ioctl(fd, WDIOC_GETTIMEOUT, &timeout)"
fi
echo ""
grep -r -n "swtd_disable" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "swtd_disable" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "ioctl(fd, KDMKTONE, unsigned int arg) must be modified/removed. Cortex-A8 platform adopts new API calls, Please use new definitions:  ioctl(fd, WDIOC_SETOPTIONS, &options)"
fi
echo ""
grep -r -n "swtd_close" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "swtd_close" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "ioctl(fd, KDMKTONE, unsigned int arg) must be modified/removed. Cortex-A8 platform adopts new API calls, Please use new definitions:  ioctl(fd, WDIOC_SETOPTIONS, &options)"
fi
echo ""




echo "================= Check Buzzer API================="
grep -r -n "KDMKTONE" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "KDMKTONE" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "ioctl(fd, KDMKTONE, unsigned int arg) must be modified/removed. Cortex-A8 platform adopts new API calls, Please use new definitions:  mx_buzzer_init(void), mx_buzzer_play_sound(), mx_buzzer_stop_sound()..."
fi
echo ""
echo "=================Check DIO API================="
grep -r -n "set_dout_state" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "set_dout_state" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "set_dout_state must be modified/removed. Cortex-A8 platform adopts new API calls, Please use new definition:  int mx_dout_set_state(int doport, int state)"
fi
echo ""
grep -r -n "get_dout_state" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "get_dout_state" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "get_dout_state must be modified/removed. Cortex-A8 platform adopts new API calls, Please use new definition:  int mx_dout_get_state(int doport, int *state)"
fi
echo ""
grep -r -n "get_din_state" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "get_din_state" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "get_din_state must be modified/removed. Cortex-A8 platform adopts new API calls, Please use new definition:  int mx_din_get_state(int diport, int *state)"
fi
echo ""
grep -r -n "set_din_event" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "set_din_event" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "set_din_event must be modified/removed. Cortex-A8 platform adopts new API calls, Please use new definition:  int mx_din_set_event(int diport, void (*func)(int diport), int mode, unsigned long duration)"
fi
echo ""
grep -r -n "get_din_event" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'
count=$(grep -r -n "get_din_event" --exclude migrate_check.sh|awk -F: '{print $1" - Line number : "$2 "  "$3$4$5 }'|wc -l)
if [ $count -gt 0 ] ; then
    echo "get_din_event must be modified/removed. Cortex-A8 platform adopts new API calls, Please use new definition:  int mx_din_get_event(int diport, int *mode, unsigned long *duration)"
fi
echo ""
echo "Finish checking.............."
echo ""
echo "Above files and line number contain old API definition of Moxa ART platform, please modify them with new definition. For new definition, prefer to moxa-arm-based-computer-linux-user-manual-for-debian-9-manual."

